#!/usr/bin/env node
import h from "lodash.template";
import F from "lodash.get";
import P from "lodash.lowerfirst";
import d from "chalk";
import { readFileSync as c } from "node:fs";
import { join as t } from "node:path";
import { rootPath as l, configRootPath as f } from "./path.config.mjs";
const D = (r, o, p) => {
  const m = {
    ...o,
    src: r.src,
    srcExample: r.srcExample,
    nameLowerFirst: P(o.name),
    $: "$"
  }, e = p.reduce(
    (i, n) => {
      let a = F(r, n);
      if (n.endsWith(".templateFilePath")) {
        const s = t(
          l,
          f,
          a
        );
        a = c(s, "utf-8");
      }
      const y = h(a);
      return i[n] = y(m), console.log(
        d.green(
          `${n}模板解析完成${Array(50 - n.length).fill("").join("_")}`
        )
      ), i;
    },
    {}
  );
  return {
    componentDirPath: t(l, e["component.dir"]),
    componentFileContent: e["component.templateFilePath"],
    componentFilePath: t(
      l,
      e["component.dir"],
      e["component.fileName"]
    ),
    componentEntryFileAddContent: e["component.entryTemplate"],
    componentEntryFilePath: t(l, e["component.entryPath"]),
    useTypeDir: !!e["type.dir"],
    typeDirPath: t(l, e["type.dir"]),
    typeFileContent: e["type.templateFilePath"],
    typeFilePath: t(l, e["type.dir"], e["type.fileName"]),
    typeEntryFileAddContent: e["type.entryTemplate"],
    typeEntryFilePath: t(l, e["type.entryPath"]),
    styleDirPath: t(l, e["style.dir"]),
    styleFileContent: e["style.templateFilePath"],
    styleFilePath: t(l, e["style.dir"], e["style.fileName"]),
    styleVarFileAddContent: e["style.varTemplate"],
    styleVarFilePath: t(l, e["style.varPath"]),
    styleEntryFileAddContent: e["style.entryTemplate"],
    styleEntryFilePath: t(l, e["style.entryPath"]),
    exampleDirPath: t(l, e["example.dir"]),
    exampleFileContent: e["example.templateFilePath"],
    exampleFilePath: t(
      l,
      e["example.dir"],
      e["example.fileName"]
    ),
    exampleEntryFileAddContent: e["example.entryTemplate"],
    exampleEntryFilePath: t(l, e["example.entryPath"])
  };
};
export {
  D as resolveTemplate
};
